=== lib/system/smd/CMakeLists.txt ===
include_directories(.)

list(APPEND SOURCES
	system/smd/smd.c
)

exports_to_parent_scope()
